<?php
namespace Controllers;
// Контроллер Настроек
class Egais extends Controller {

	public function __construct() {
		parent::__construct();
		$this->model=new \Models\Egais($this->db, $this->f3);
	}

	// Главная страница (Входящие документы)
	function main() {
		$limit=$this->f3->get('lines_of_page');
		$page=$this->f3->get('GET.page');
		if(!$page)$page=1;
		$data=$this->model->out_list($limit, ($page-1)*$limit);
		$this->f3->set('pagination', $this->pagination($data['total'], $page));
		if($data['success']) {
			$data['receipts']=$this->model->filtr_type($data['receipts'], array('replyrests', 'replynattn', 'waybillticket', 'waybill_v4', 'waybillact_v4'));
		}
		$this->f3->set('data', $data);
		$this->f3->set('page_data', $this->model->page_data('main'));
	}

	function preview_waybill_v4() {
		$get=$this->f3->get('GET');
		$ttn=$this->model->ttn($get['id']);
		if(!$ttn['success']) {
			$this->f3->set('page_data', $this->messages->message($ttn['txt']));
			return;
		}
		$this->f3->set('ttn', $ttn['ttn']);
		$this->f3->set('page_data', $this->model->page_data('waybill_v4'));
	}

	function preview_replyrests() {
		$get=$this->f3->get('GET');
		$rests=$this->model->rests_array($get['id']);
		if(!$rests['success']) {
			$this->f3->set('page_data', $this->messages->message($rests['txt']));
			return;
		}
		$this->f3->set('rests', $rests['receipt']);
		$this->f3->set('page_data', $this->model->page_data('replyrests'));
	}

	// Просмотр документа
	function ticket() {
		$get=$this->f3->get('GET');
		if(method_exists($this, 'preview_'.$get['type'])) {
			$class='preview_'.$get['type'];
			return $this->$class();
		}
		$ticket=$this->model->ticket($get['folder'], $get['type'], $get['id']);
		$this->f3->set('ticket', $ticket);
		$this->f3->set('page_data', $this->model->page_data('ticket'));
	}

	// Служебная информация
	function utminfo() {
		$res=$this->model->utminfo();
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		$this->f3->set('data', $res);
		$this->f3->set('page_data', $this->model->page_data('utminfo'));
	}

	// Запрос остатков
	function rests() {
		$res=$this->model->rests();
		$this->f3->set('data', $res);
		$this->f3->set('page_data', $this->messages->message($res['txt']));
	}

	// Акт по накладной
	function ttnact() {
		$get=$this->f3->get('GET');
		$ttn=$this->model->ttn($get['id']);
		if(!$ttn['success']) {
			$this->f3->set('page_data', $this->messages->message($ttn['txt']));
			return;
		}
		if($ttn['ttn']['identity']) {
			// Пытаемся найти regId
			$regid=$this->model->ttn_regid($ttn['ttn']);
			if($regid['success']) {
				$ttn['ttn']['regid']=$regid['regid'];
				if($regid['position']) {
					foreach ($regid['position'] as $i => $v) {
						$ttn['ttn']['products'][(string)$i]=array_merge($ttn['ttn']['products'][(string)$i], $v);
					}
				}
			}
		}
		$this->f3->set('ttn', $ttn['ttn']);
		if($get['accept']=='repeal') {
			$this->f3->set('page_data', $this->model->page_data('ttnact_repeal'));
		}
		else {
			$this->f3->set('page_data', $this->model->page_data('ttnact'));
		}
	}

	// Отправка акта по накладной
	function post_ttnact() {
		$post=$this->f3->get('POST');
		$res=$this->model->ttnact($post);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Отправка запроса отмены акта по накладной
	function post_ttnact_repeal() {
		$post=$this->f3->get('POST');
		$res=$this->model->ttnact_repeal($post);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
		exit();
	}

	// Запрос на получения списка необработанных накладных
	function nattn() {
		$res=$this->model->nattn();
		$this->f3->set('data', $res);
		$this->f3->set('page_data', $this->messages->message($res['txt']));
	}

	// Списание
	function writeoff() {
		$rests=$this->model->get_rests();
		if(!$rests['success']) {
			$rests['txt']=$this->messages->message($res['txt'])['txt'];
		}
		$this->f3->set('data', $rests);
		$this->f3->set('page_data', $this->model->page_data('writeoff'));
	}

	// Отправка запроса на списание
	function post_writeoff() {
		$post=$this->f3->get('POST');
		$res=$this->model->writeoff($post);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
	}

	// Отменить списание
	function writeoff_repeal() {
		$this->f3->set('page_data', $this->model->page_data('writeoff_repeal'));
	}

	// Отправка отмены списания
	function post_writeoff_repeal() {
		$post=$this->f3->get('POST');
		$res=$this->model->writeoff_repeal($post);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
	}

	// Накладная
	function createttn() {
		$rests=$this->model->get_rests();
		if(!$rests['success']) {
			$rests['txt']=$this->messages->message($rests['txt'])['txt'];
		}
		$this->f3->set('data', $rests);
		$this->f3->set('page_data', $this->model->page_data('ttn'));
	}

	// Отправка накладной
	function post_createttn() {
		$post=$this->f3->get('POST');
		$res=$this->model->createttn($post);
		$res['txt']=$this->messages->message($res['txt'])['txt'];
		echo json_encode($res);
	}

	// Поиск организации
	function organizations() {
		$get=$this->f3->get('GET');
		$data=$this->model->get_organization($get);
		if(!$data['success']) {
			$data['txt']=$this->messages->message($data['txt'])['txt'];
		}
		$this->f3->set('data', $data);
		$this->f3->set('page_data', $this->model->page_data('organizations'));
	}

	// Актуализация пивных остатков
	function beer_currentstock() {
		$rests=$this->model->get_rests();
		if(!$rests['success']) {
			$rests['txt']=$this->messages->message($rests['txt'])['txt'];
			$data=$rests;
		}
		else {
			$api=new \Models\Api($this->f3, $this->api_data['domen'], $this->api_data['pass'], $this->api_data['store_id'], $this->api_data['count']);
			$beer=$api->beers_stock();
			if(!$beer['success']) {
				$data=$beer;
			}
			else {
				$positions=$this->model->beer_currentstock($rests['receipt']['positions'], $beer['stock']);
				if($positions['success']) {
					$rests['positions']=$positions['positions'];
					$rests['error']=$positions['error'];
				}
				$data=$rests;
			}
		}
		$this->f3->set('data', $data);
		$this->f3->set('page_data', $this->model->page_data('beer_currentstock'));
	}

	function related() {
		$get=$this->f3->get('GET');
		$receipts=$this->model->related($get['id']);
		if(!$receipts['success']) {
			$receipts['txt']=$this->messages->message($receipts['txt'])['txt'];
		}
		$this->f3->set('receipts', $receipts);
		$this->f3->set('page_data', $this->model->page_data('related'));
	}
}